Index: src/includes/classes/Smarty/sysplugins/smarty_internal_template.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_template.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_template.php	(revision )
@@ -138,502 +108,206 @@
         $this->parent = $_parent;
         // Template resource
         $this->template_resource = $template_resource;
-        // copy block data of template inheritance
-        if ($this->parent instanceof Smarty_Internal_Template) {
-            $this->block_data = $this->parent->block_data;
+        $this->source = Smarty_Template_Source::load($this);
+        parent::__construct();
-        }
+    }
-    }
 
     /**
-     * Returns if the current template must be compiled by the Smarty compiler
-     * It does compare the timestamps of template source and the compiled templates and checks the force compile configuration
+     * render template
      *
+     * @param  bool $merge_tpl_vars   if true parent template variables merged in to local scope
+     * @param  bool $no_output_filter if true do not run output filter
+     * @param  bool $display          true: display, false: fetch null: subtemplate
+     *
+     * @throws Exception
      * @throws SmartyException
-     * @return boolean true if the template must be compiled
+     * @return string rendered template output
      */
-    public function mustCompile()
+    public function render($no_output_filter = true, $display = null)
     {
+        $parentIsTpl = isset($this->parent) && $this->parent->_objType == 2;
+        if ($this->smarty->debugging) {
+            $this->smarty->_debug->start_template($this, $display);
+        }
+        // checks if template exists
         if (!$this->source->exists) {
-            if ($this->parent instanceof Smarty_Internal_Template) {
-                $parent_resource = " in '$this->parent->template_resource}'";
+            if ($parentIsTpl) {
+                $parent_resource = " in '{$this->parent->template_resource}'";
             } else {
                 $parent_resource = '';
             }
             throw new SmartyException("Unable to load template {$this->source->type} '{$this->source->name}'{$parent_resource}");
         }
-        if ($this->mustCompile === null) {
-            $this->mustCompile = (!$this->source->uncompiled && ($this->smarty->force_compile || $this->source->recompiled || $this->compiled->timestamp === false ||
-                    ($this->smarty->compile_check && $this->compiled->timestamp < $this->source->timestamp)));
+        // disable caching for evaluated code
+        if ($this->source->handler->recompiled) {
+            $this->caching = false;
         }
-
-        return $this->mustCompile;
+        // read from cache or render
+        $isCacheTpl =
+            $this->caching == Smarty::CACHING_LIFETIME_CURRENT || $this->caching == Smarty::CACHING_LIFETIME_SAVED;
+        if ($isCacheTpl) {
+            if (!isset($this->cached)) {
+                $this->loadCached();
-    }
+            }
+            $this->cached->render($this, $no_output_filter);
+        } elseif ($this->source->handler->uncompiled) {
+            $this->source->render($this);
+        } else {
+            if (!isset($this->compiled)) {
+                $this->loadCompiled();
+            }
+            $this->compiled->render($this);
+        }
 
-    /**
-     * Compiles the template
-     * If the template is not evaluated the compiled template is saved on disk
-     */
-    public function compileTemplateSource()
-    {
-        if (!$this->source->recompiled) {
-            $this->properties['file_dependency'] = array();
-            if ($this->source->components) {
-                // for the extends resource the compiler will fill it
-                // uses real resource for file dependency
-                // $source = end($this->source->components);
-                // $this->properties['file_dependency'][$this->source->uid] = array($this->source->filepath, $this->source->timestamp, $source->type);
+        // display or fetch
+        if ($display) {
+            if ($this->caching && $this->smarty->cache_modified_check) {
+                $this->smarty->ext->_cachemodify->cacheModifiedCheck($this->cached, $this,
+                                                                     isset($content) ? $content : ob_get_clean());
             } else {
-                $this->properties['file_dependency'][$this->source->uid] = array($this->source->filepath, $this->source->timestamp, $this->source->type);
+                if ((!$this->caching || $this->cached->has_nocache_code || $this->source->handler->recompiled) &&
+                    !$no_output_filter && (isset($this->smarty->autoload_filters['output']) ||
+                        isset($this->smarty->registered_filters['output']))
+                ) {
+                    echo $this->smarty->ext->_filterHandler->runFilter('output', ob_get_clean(), $this);
+                } else {
+                    ob_end_flush();
+                    flush();
-            }
-        }
+                }
+            }
-        // compile locking
-        if ($this->smarty->compile_locking && !$this->source->recompiled) {
-            if ($saved_timestamp = $this->compiled->timestamp) {
-                touch($this->compiled->filepath);
+            if ($this->smarty->debugging) {
+                $this->smarty->_debug->end_template($this);
+                // debug output
+                $this->smarty->_debug->display_debug($this, true);
             }
+            return '';
+        } else {
+            if ($this->smarty->debugging) {
+                $this->smarty->_debug->end_template($this);
+                if ($this->smarty->debugging === 2 && $display === false) {
+                    $this->smarty->_debug->display_debug($this, true);
-        }
+                }
-        // call compiler
-        try {
-            $code = $this->compiler->compileTemplate($this);
-        }
+            }
-        catch (Exception $e) {
-            // restore old timestamp in case of error
-            if ($this->smarty->compile_locking && !$this->source->recompiled && $saved_timestamp) {
-                touch($this->compiled->filepath, $saved_timestamp);
+            if ($parentIsTpl) {
+                if (!empty($this->tpl_function)) {
+                    $this->parent->tpl_function = array_merge($this->parent->tpl_function, $this->tpl_function);
-            }
+                }
-            throw $e;
+                foreach ($this->compiled->required_plugins as $code => $tmp1) {
+                    foreach ($tmp1 as $name => $tmp) {
+                        foreach ($tmp as $type => $data) {
+                            $this->parent->compiled->required_plugins[$code][$name][$type] = $data;
-        }
+                        }
-        // compiling succeded
-        if (!$this->source->recompiled && $this->compiler->write_compiled_code) {
-            // write compiled template
-            $_filepath = $this->compiled->filepath;
-            if ($_filepath === false) {
-                throw new SmartyException('getCompiledFilepath() did not return a destination to save the compiled template to');
-            }
+                    }
-            Smarty_Internal_Write_File::writeFile($_filepath, $code, $this->smarty);
-            $this->compiled->exists = true;
-            $this->compiled->isCompiled = true;
-        }
+                }
-        // release compiler object to free memory
-        unset($this->compiler);
-    }
+            }
-
-    /**
-     * Writes the cached template output
-     *
-     * @param string $content
-     *
-     * @return bool
-     */
-    public function writeCachedContent($content)
-    {
-        if ($this->source->recompiled || !($this->caching == Smarty::CACHING_LIFETIME_CURRENT || $this->caching == Smarty::CACHING_LIFETIME_SAVED)) {
-            // don't write cache file
-            return false;
+            if (!$no_output_filter &&
+                (!$this->caching || $this->cached->has_nocache_code || $this->source->handler->recompiled) &&
+                (isset($this->smarty->autoload_filters['output']) || isset($this->smarty->registered_filters['output']))
+            ) {
+                return $this->smarty->ext->_filterHandler->runFilter('output', ob_get_clean(), $this);
-        }
+            }
-        $this->cached->timestamp = time();
-        $this->properties['cache_lifetime'] = $this->cache_lifetime;
-        $this->properties['unifunc'] = 'content_' . str_replace(array('.', ','), '_', uniqid('', true));
-        $content = $this->createTemplateCodeFrame($content, true);
-        /** @var Smarty_Internal_Template $_smarty_tpl
-         * used in evaluated code
-         */
-        $_smarty_tpl = $this;
-        eval("?>" . $content);
-        $this->cached->valid = true;
-        $this->cached->processed = true;
-
-        return $this->cached->write($this, $content);
+            // return cache content
+            return null;
-    }
+        }
+    }
 
     /**
-     * Template code runtime function to get subtemplate content
-     *
-     * @param string  $template       the resource handle of the template file
-     * @param mixed   $cache_id       cache id to be used with this template
-     * @param mixed   $compile_id     compile id to be used with this template
-     * @param integer $caching        cache mode
-     * @param integer $cache_lifetime life time of cache data
-     * @param         $data
-     * @param int     $parent_scope   scope in which {include} should execute
-     *
-     * @returns string template content
+     * Compiles the template
+     * If the template is not evaluated the compiled template is saved on disk
      */
-    public function getSubTemplate($template, $cache_id, $compile_id, $caching, $cache_lifetime, $data, $parent_scope)
+    public function compileTemplateSource()
     {
-        // already in template cache?
-        if ($this->smarty->allow_ambiguous_resources) {
-            $_templateId = Smarty_Resource::getUniqueTemplateName($this, $template) . $cache_id . $compile_id;
-        } else {
-            $_templateId = $this->smarty->joined_template_dir . '#' . $template . $cache_id . $compile_id;
+        return $this->compiled->compileTemplateSource($this);
-        }
+    }
 
-        if (isset($_templateId[150])) {
-            $_templateId = sha1($_templateId);
-        }
-        if (isset($this->smarty->template_objects[$_templateId])) {
-            // clone cached template object because of possible recursive call
-            $tpl = clone $this->smarty->template_objects[$_templateId];
-            $tpl->parent = $this;
-            $tpl->caching = $caching;
-            $tpl->cache_lifetime = $cache_lifetime;
-        } else {
-            $tpl = new $this->smarty->template_class($template, $this->smarty, $this, $cache_id, $compile_id, $caching, $cache_lifetime);
-        }
-        // get variables from calling scope
-        if ($parent_scope == Smarty::SCOPE_LOCAL) {
-            $tpl->tpl_vars = $this->tpl_vars;
-            $tpl->tpl_vars['smarty'] = clone $this->tpl_vars['smarty'];
-        } elseif ($parent_scope == Smarty::SCOPE_PARENT) {
-            $tpl->tpl_vars = & $this->tpl_vars;
-        } elseif ($parent_scope == Smarty::SCOPE_GLOBAL) {
-            $tpl->tpl_vars = & Smarty::$global_tpl_vars;
-        } elseif (($scope_ptr = $this->getScopePointer($parent_scope)) == null) {
-            $tpl->tpl_vars = & $this->tpl_vars;
-        } else {
-            $tpl->tpl_vars = & $scope_ptr->tpl_vars;
-        }
-        $tpl->config_vars = $this->config_vars;
-        if (!empty($data)) {
-            // set up variable values
-            foreach ($data as $_key => $_val) {
-                $tpl->tpl_vars[$_key] = new Smarty_variable($_val);
-            }
-        }
-
-        return $tpl->fetch(null, null, null, null, false, false, true);
-    }
-
     /**
-     * Template code runtime function to set up an inline subtemplate
+     * Writes the content to cache resource
      *
-     * @param string  $template       the resource handle of the template file
-     * @param mixed   $cache_id       cache id to be used with this template
-     * @param mixed   $compile_id     compile id to be used with this template
-     * @param integer $caching        cache mode
-     * @param integer $cache_lifetime life time of cache data
-     * @param         $data
-     * @param int     $parent_scope   scope in which {include} should execute
-     * @param string  $hash           nocache hash code
+     * @param string $content
      *
-     * @returns string template content
+     * @return bool
      */
-    public function setupInlineSubTemplate($template, $cache_id, $compile_id, $caching, $cache_lifetime, $data, $parent_scope, $hash)
+    public function writeCachedContent($content)
     {
-        $tpl = new $this->smarty->template_class($template, $this->smarty, $this, $cache_id, $compile_id, $caching, $cache_lifetime);
-        $tpl->properties['nocache_hash'] = $hash;
-        // get variables from calling scope
-        if ($parent_scope == Smarty::SCOPE_LOCAL) {
-            $tpl->tpl_vars = $this->tpl_vars;
-            $tpl->tpl_vars['smarty'] = clone $this->tpl_vars['smarty'];
-        } elseif ($parent_scope == Smarty::SCOPE_PARENT) {
-            $tpl->tpl_vars = & $this->tpl_vars;
-        } elseif ($parent_scope == Smarty::SCOPE_GLOBAL) {
-            $tpl->tpl_vars = & Smarty::$global_tpl_vars;
-        } elseif (($scope_ptr = $this->getScopePointer($parent_scope)) == null) {
-            $tpl->tpl_vars = & $this->tpl_vars;
-        } else {
-            $tpl->tpl_vars = & $scope_ptr->tpl_vars;
+        return $this->smarty->ext->_updateCache->writeCachedContent($this->cached, $this, $content);
-        }
+    }
-        $tpl->config_vars = $this->config_vars;
-        if (!empty($data)) {
-            // set up variable values
-            foreach ($data as $_key => $_val) {
-                $tpl->tpl_vars[$_key] = new Smarty_variable($_val);
-            }
-        }
 
-        return $tpl;
-    }
-
     /**
-     * Create code frame for compiled and cached templates
+     * Get unique template id
      *
-     * @param  string $content optional template content
-     * @param  bool   $cache   flag for cache file
-     *
      * @return string
      */
-    public function createTemplateCodeFrame($content = '', $cache = false)
+    public function _getTemplateId()
     {
-        $plugins_string = '';
-        // include code for plugins
-        if (!$cache) {
-            if (!empty($this->required_plugins['compiled'])) {
-                $plugins_string = '<?php ';
-                foreach ($this->required_plugins['compiled'] as $tmp) {
-                    foreach ($tmp as $data) {
-                        $file = addslashes($data['file']);
-                        if (is_Array($data['function'])) {
-                            $plugins_string .= "if (!is_callable(array('{$data['function'][0]}','{$data['function'][1]}'))) include '{$file}';\n";
-                        } else {
-                            $plugins_string .= "if (!is_callable('{$data['function']}')) include '{$file}';\n";
+        return isset($this->templateId) ? $this->templateId : $this->templateId =
+            $this->smarty->_getTemplateId($this->template_resource, $this->cache_id, $this->compile_id);
-                        }
+    }
-                    }
-                }
-                $plugins_string .= '?>';
-            }
-            if (!empty($this->required_plugins['nocache'])) {
-                $this->has_nocache_code = true;
-                $plugins_string .= "<?php echo '/*%%SmartyNocache:{$this->properties['nocache_hash']}%%*/<?php \$_smarty = \$_smarty_tpl->smarty; ";
-                foreach ($this->required_plugins['nocache'] as $tmp) {
-                    foreach ($tmp as $data) {
-                        $file = addslashes($data['file']);
-                        if (is_Array($data['function'])) {
-                            $plugins_string .= addslashes("if (!is_callable(array('{$data['function'][0]}','{$data['function'][1]}'))) include '{$file}';\n");
-                        } else {
-                            $plugins_string .= addslashes("if (!is_callable('{$data['function']}')) include '{$file}';\n");
-                        }
-                    }
-                }
-                $plugins_string .= "?>/*/%%SmartyNocache:{$this->properties['nocache_hash']}%%*/';?>\n";
-            }
-        }
-        // build property code
-        $this->properties['has_nocache_code'] = $this->has_nocache_code;
-        $output = '';
-        if (!$this->source->recompiled) {
-            $output = "<?php /*%%SmartyHeaderCode:{$this->properties['nocache_hash']}%%*/";
-            if ($this->smarty->direct_access_security) {
-                $output .= "if(!defined('SMARTY_DIR')) exit('no direct access allowed');\n";
-            }
-        }
-        if ($cache) {
-            // remove compiled code of{function} definition
-            unset($this->properties['function']);
-            if (!empty($this->smarty->template_functions)) {
-                // copy code of {function} tags called in nocache mode
-                foreach ($this->smarty->template_functions as $name => $function_data) {
-                    if (isset($function_data['called_nocache'])) {
-                        foreach ($function_data['called_functions'] as $func_name) {
-                            $this->smarty->template_functions[$func_name]['called_nocache'] = true;
-                        }
-                    }
-                }
-                foreach ($this->smarty->template_functions as $name => $function_data) {
-                    if (isset($function_data['called_nocache'])) {
-                        unset($function_data['called_nocache'], $function_data['called_functions'], $this->smarty->template_functions[$name]['called_nocache']);
-                        $this->properties['function'][$name] = $function_data;
-                    }
-                }
-            }
-        }
-        $this->properties['version'] = Smarty::SMARTY_VERSION;
-        if (!isset($this->properties['unifunc'])) {
-            $this->properties['unifunc'] = 'content_' . str_replace(array('.', ','), '_', uniqid('', true));
-        }
-        if (!$this->source->recompiled) {
-            $output .= "\$_valid = \$_smarty_tpl->decodeProperties(" . var_export($this->properties, true) . ',' . ($cache ? 'true' : 'false') . "); /*/%%SmartyHeaderCode%%*/?>\n";
-            $output .= '<?php if ($_valid && !is_callable(\'' . $this->properties['unifunc'] . '\')) {function ' . $this->properties['unifunc'] . '($_smarty_tpl) {?>';
-        }
-        $output .= $plugins_string;
-        $output .= $content;
-        if (!$this->source->recompiled) {
-            $output .= "<?php }} ?>\n";
-        }
 
-        return $output;
-    }
-
     /**
-     * This function is executed automatically when a compiled or cached template file is included
-     * - Decode saved properties from compiled template and cache files
-     * - Check if compiled or cache file is valid
-     *
-     * @param  array $properties special template properties
-     * @param  bool  $cache      flag if called from cache file
-     *
-     * @return bool  flag if compiled or cache file is valid
+     * runtime error not matching capture tags
      */
-    public function decodeProperties($properties, $cache = false)
+    public function capture_error()
     {
-        $this->has_nocache_code = $properties['has_nocache_code'];
-        $this->properties['nocache_hash'] = $properties['nocache_hash'];
-        if (isset($properties['cache_lifetime'])) {
-            $this->properties['cache_lifetime'] = $properties['cache_lifetime'];
+        throw new SmartyException("Not matching {capture} open/close in \"{$this->template_resource}\"");
-        }
+    }
-        if (isset($properties['file_dependency'])) {
-            $this->properties['file_dependency'] = array_merge($this->properties['file_dependency'], $properties['file_dependency']);
-        }
-        if (!empty($properties['function'])) {
-            $this->properties['function'] = array_merge($this->properties['function'], $properties['function']);
-            $this->smarty->template_functions = array_merge($this->smarty->template_functions, $properties['function']);
-        }
-        $this->properties['version'] = (isset($properties['version'])) ? $properties['version'] : '';
-        $this->properties['unifunc'] = $properties['unifunc'];
-        // check file dependencies at compiled code
-        $is_valid = true;
-        if ($this->properties['version'] != Smarty::SMARTY_VERSION) {
-            $is_valid = false;
-        } elseif (((!$cache && $this->smarty->compile_check && empty($this->compiled->_properties) && !$this->compiled->isCompiled) || $cache && ($this->smarty->compile_check === true || $this->smarty->compile_check === Smarty::COMPILECHECK_ON)) && !empty($this->properties['file_dependency'])) {
-            foreach ($this->properties['file_dependency'] as $_file_to_check) {
-                if ($_file_to_check[2] == 'file' || $_file_to_check[2] == 'php') {
-                    if ($this->source->filepath == $_file_to_check[0] && isset($this->source->timestamp)) {
-                        // do not recheck current template
-                        $mtime = $this->source->timestamp;
-                    } else {
-                        // file and php types can be checked without loading the respective resource handlers
-                        $mtime = @filemtime($_file_to_check[0]);
-                    }
-                } elseif ($_file_to_check[2] == 'string') {
-                    continue;
-                } else {
-                    $source = Smarty_Resource::source(null, $this->smarty, $_file_to_check[0]);
-                    $mtime = $source->timestamp;
-                }
-                if (!$mtime || $mtime > $_file_to_check[1]) {
-                    $is_valid = false;
-                    break;
-                }
-            }
-        }
-        if ($cache) {
-            // CACHING_LIFETIME_SAVED cache expiry has to be validated here since otherwise we'd define the unifunc
-            if ($this->caching === Smarty::CACHING_LIFETIME_SAVED &&
-                $this->properties['cache_lifetime'] >= 0 &&
-                (time() > ($this->cached->timestamp + $this->properties['cache_lifetime']))
-            ) {
-                $is_valid = false;
-            }
-            $this->cached->valid = $is_valid;
-        } else {
-            $this->mustCompile = !$is_valid;
-        }
-        // store data in reusable Smarty_Template_Compiled
-        if (!$cache) {
-            $this->compiled->_properties = $properties;
-        }
 
-        return $is_valid;
-    }
-
     /**
-     * Template code runtime function to create a local Smarty variable for array assignments
+     * Load compiled object
      *
-     * @param string $tpl_var tempate variable name
-     * @param bool   $nocache cache mode of variable
-     * @param int    $scope   scope of variable
      */
-    public function createLocalArrayVariable($tpl_var, $nocache = false, $scope = Smarty::SCOPE_LOCAL)
+    public function loadCompiled()
     {
-        if (!isset($this->tpl_vars[$tpl_var])) {
-            $this->tpl_vars[$tpl_var] = new Smarty_variable(array(), $nocache, $scope);
-        } else {
-            $this->tpl_vars[$tpl_var] = clone $this->tpl_vars[$tpl_var];
-            if ($scope != Smarty::SCOPE_LOCAL) {
-                $this->tpl_vars[$tpl_var]->scope = $scope;
+        if (!isset($this->compiled)) {
+            $this->compiled = Smarty_Template_Compiled::load($this);
-            }
+        }
-            if (!(is_array($this->tpl_vars[$tpl_var]->value) || $this->tpl_vars[$tpl_var]->value instanceof ArrayAccess)) {
-                settype($this->tpl_vars[$tpl_var]->value, 'array');
-            }
+    }
-        }
-    }
 
     /**
-     * Template code runtime function to get pointer to template variable array of requested scope
+     * Load cached object
      *
-     * @param  int $scope requested variable scope
-     *
-     * @return array array of template variables
      */
-    public function &getScope($scope)
+    public function loadCached()
     {
-        if ($scope == Smarty::SCOPE_PARENT && !empty($this->parent)) {
-            return $this->parent->tpl_vars;
-        } elseif ($scope == Smarty::SCOPE_ROOT && !empty($this->parent)) {
-            $ptr = $this->parent;
-            while (!empty($ptr->parent)) {
-                $ptr = $ptr->parent;
+        if (!isset($this->cached)) {
+            $this->cached = Smarty_Template_Cached::load($this);
-            }
+        }
-
-            return $ptr->tpl_vars;
-        } elseif ($scope == Smarty::SCOPE_GLOBAL) {
-            return Smarty::$global_tpl_vars;
-        }
+    }
-        $null = null;
 
-        return $null;
-    }
-
     /**
-     * Get parent or root of template parent chain
+     * Load compiler object
      *
-     * @param  int $scope pqrent or root scope
-     *
-     * @return mixed object
+     * @throws \SmartyException
      */
-    public function getScopePointer($scope)
+    public function loadCompiler()
     {
-        if ($scope == Smarty::SCOPE_PARENT && !empty($this->parent)) {
-            return $this->parent;
-        } elseif ($scope == Smarty::SCOPE_ROOT && !empty($this->parent)) {
-            $ptr = $this->parent;
-            while (!empty($ptr->parent)) {
-                $ptr = $ptr->parent;
+        if (!class_exists($this->source->handler->compiler_class)) {
+            $this->smarty->loadPlugin($this->source->handler->compiler_class);
-            }
+        }
-
-            return $ptr;
+        $this->compiler = new $this->source->handler->compiler_class($this->source->handler->template_lexer_class,
+                                                                     $this->source->handler->template_parser_class,
+                                                                     $this->smarty);
-        }
+    }
 
-        return null;
-    }
-
     /**
-     * [util function] counts an array, arrayaccess/traversable or PDOStatement object
+     * Handle unknown class methods
      *
-     * @param  mixed $value
+     * @param string $name unknown method-name
+     * @param array  $args argument array
      *
-     * @return int   the count for arrays and objects that implement countable, 1 for other objects that don't, and 0 for empty elements
+     * @return mixed
+     * @throws SmartyException
      */
-    public function _count($value)
+    public function __call($name, $args)
     {
-        if (is_array($value) === true || $value instanceof Countable) {
-            return count($value);
-        } elseif ($value instanceof IteratorAggregate) {
-            // Note: getIterator() returns a Traversable, not an Iterator
-            // thus rewind() and valid() methods may not be present
-            return iterator_count($value->getIterator());
-        } elseif ($value instanceof Iterator) {
-            return iterator_count($value);
-        } elseif ($value instanceof PDOStatement) {
-            return $value->rowCount();
-        } elseif ($value instanceof Traversable) {
-            return iterator_count($value);
-        } elseif ($value instanceof ArrayAccess) {
-            if ($value->offsetExists(0)) {
-                return 1;
+        // method of Smarty object?
+        if (method_exists($this->smarty, $name)) {
+            return call_user_func_array(array($this->smarty, $name), $args);
-            }
+        }
-        } elseif (is_object($value)) {
-            return count($value);
+        // parent
+        return parent::__call($name, $args);
-        }
+    }
 
-        return 0;
-    }
-
     /**
-     * runtime error not matching capture tags
-
-     */
-    public function capture_error()
-    {
-        throw new SmartyException("Not matching {capture} open/close in \"{$this->template_resource}\"");
-    }
-
-    /**
-     * Empty cache for this template
-     *
-     * @param integer $exp_time expiration time
-     *
-     * @return integer number of cache files deleted
-     */
-    public function clearCache($exp_time = null)
-    {
-        Smarty_CacheResource::invalidLoadedCache($this->smarty);
-
-        return $this->cached->handler->clear($this->smarty, $this->template_name, $this->cache_id, $this->compile_id, $exp_time);
-    }
-
-    /**
      * set Smarty property in template context
      *
      * @param string $property_name property name
@@ -644,23 +318,18 @@
     public function __set($property_name, $value)
     {
         switch ($property_name) {
-            case 'source':
             case 'compiled':
             case 'cached':
             case 'compiler':
                 $this->$property_name = $value;
-
                 return;
-
-            // FIXME: routing of template -> smarty attributes
             default:
+                // Smarty property ?
                 if (property_exists($this->smarty, $property_name)) {
                     $this->smarty->$property_name = $value;
-
                     return;
                 }
         }
-
         throw new SmartyException("invalid template property '$property_name'.");
     }
 
